import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class sets up the maze and backgrounds
 * 
 * @author Ian King 
 * @version 9-7-11
 */
public class Maze extends World
{
    private static final int startRoom = 1; // starting position
    private static final int startDir = 2; // start direction
    private static final int no_of_directions = 5;                            // N,S E and W
    private static final int no_of_rooms = 18;                                // 4 x 4 maze
    private static final int no_of_backgrounds = 18;
    public static int [] [] roomarray = new int [no_of_directions][no_of_rooms];
    public static GreenfootImage [] backgroundarray = new GreenfootImage[no_of_backgrounds];
    
    
// map

    /**
     * Constructor for objects of class maze.
     * 
     */
    public Maze()
    
    
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        map();
        prepare();
        
      
        RoomLabel label2 = new RoomLabel("Use Arrow keys to move, N,S,E,W to change view.");
        addObject (label2, 950,380);
        
        Room room = new Room(label2);    
        addObject(room,1000,1000);
         
               
        
      
    }

    public void map(){
        // The constructor is responsible for setting up the map.
 
        for(int roomindex = 1; roomindex < no_of_rooms; roomindex++)
            for (int direction = 1; direction < no_of_directions; direction++)
                roomarray[direction][roomindex]=-1;

        roomarray[1][1] = 8;
        roomarray[1][2] = 7;
        roomarray[2][2] = 3;
        roomarray[1][3] = 6;
        roomarray[4][3] = 2;
        roomarray[1][4] = 5;
        roomarray[1][5] = 12;
        roomarray[3][5] = 4;
        roomarray[4][5] = 6;
        roomarray[2][6] = 5;
        roomarray[3][6] = 3;
        roomarray[3][7] = 2;
        roomarray[4][7] = 8;
        roomarray[2][8] = 7;
        roomarray[3][8] = 1;
        roomarray[1][9] = 16;
        roomarray[2][9] = 10;
        roomarray[1][10] = 15;
        roomarray[4][10] = 9;
        roomarray[1][11] = 14;
        roomarray[2][11] = 12;
        roomarray[3][12] = 5;
        roomarray[4][12] = 11;
        roomarray[4][13] = 14;
        roomarray[2][14] = 13;
        roomarray[4][14] = 15;
        roomarray[3][14] = 11;
        roomarray[3][15] = 10;
        roomarray[2][15] = 14;
        roomarray[4][16] = 17;
        roomarray[3][16] = 9;
    }

    public void fill_backgroundarray() {
        
        backgroundarray[1] = new GreenfootImage("image1.jpg");
        backgroundarray[2] = new GreenfootImage("image2.jpg");
        backgroundarray[3] = new GreenfootImage("image3.jpg");
        backgroundarray[4] = new GreenfootImage("image4.jpg");
        backgroundarray[5] = new GreenfootImage("image5.jpg");
        backgroundarray[6] = new GreenfootImage("image6.jpg");
        backgroundarray[7] = new GreenfootImage("image7.jpg");
        backgroundarray[8] = new GreenfootImage("image8.jpg");
        backgroundarray[9] = new GreenfootImage("image1.jpg");
        backgroundarray[10] = new GreenfootImage("image1.jpg");
        backgroundarray[11] = new GreenfootImage("image1.jpg");
        backgroundarray[12] = new GreenfootImage("image1.jpg");
        backgroundarray[13] = new GreenfootImage("image1.jpg");
        backgroundarray[14] = new GreenfootImage("image1.jpg");
        backgroundarray[15] = new GreenfootImage("image1.jpg");
        backgroundarray[16] = new GreenfootImage("image1.jpg");
        backgroundarray[17] = new GreenfootImage("image9.jpg");
    }
    

    /**
     * Prepare the world for the start of the program. That is: fill arrays (map and backgrounds)
     */
    private void prepare()
    {
        map();
        fill_backgroundarray();
         int roomNumber = startRoom;
        int direction = startDir;
         setBackground(backgroundarray[roomNumber]);

    
    }
    
    
    }
